<script setup lang="ts">
// import { ZoomMtg } from '@zoomus/websdk'
import { parseISO } from 'date-fns'
import { storeToRefs } from 'pinia'
import { onClickOutside } from '@vueuse/core'
import { useZoomClientStore } from '~/store/zoomClient'
import { useAccountStore } from '~~/store/account'
import { useCallStore } from '~~/store/call'
import { useUIStore } from '~~/store/UI'
import { useZoomStore } from '~~/store/zoom'

const MESSAGE_ALERT = {
  LEAVE_MEETING_TITLE: '配信を終了する場合は、配信終了を押して終了ください。',
  LEAVE_MEETING_MESSAGE: '配信を終了せずに、退出します。よろしいですか？',
  CHANGE_NAME_ERROR: '名前の変更に失敗しました。しばらくたってからお試しください。',
}

const tempObj = {
  info: '情報',
  comment: 'コメント',
  question: '質問',
  poll: 'アンケート',
}

const account = useAccountStore()
const zoom = useZoomStore()
const zoomClient = useZoomClientStore()
const call = useCallStore()
const { currentCall } = storeToRefs(call)
const { loading } = storeToRefs(zoomClient)

const ui = useUIStore()
const { waitingRoom, isDesign7, selectedTitle, sideBar, isMobile } = storeToRefs(ui)
const menu = ref(false)
const openSelected = (title: string) => {
  menu.value = false
  selectedTitle.value = title
  sideBar.value = true
}

const handleCloseMenu = (): void => {
  if (!menu.value) {
    menu.value = true
    sideBar.value = false
  }
  else {
    menu.value = !menu.value
  }
}

const expiration = computed(() => currentCall.value?.call?.expiration)
const expirationConvert = computed(() => parseISO(expiration.value ?? ''))
const recordTimeStamp = computed(() => currentCall.value?.call?.record)

const target = ref(null)
onClickOutside(target, () => {
  menu.value = false
})

// modal
const modal = ref(false)
const toggleModal = useToggle(modal)
const inputNameEvent = async (name: string) => {
  ZoomMtg.getCurrentUser({
    success: (i: any) => {
      ZoomMtg.rename({
        userId: i.result.currentUser.userId,
        oldName: i.result.currentUser.userName,
        newName: name,
        error: (i: any) => console.log(i),
      })
    },
  })

  toggleModal()
  await sleep(500)
  ZoomMtg.getCurrentUser({
    success: (i: any) => {
      if (i.result.currentUser.userName !== name) {
        zoomClient.modalMessage = MESSAGE_ALERT.CHANGE_NAME_ERROR
        return
      }
      account.changeName(name)
    },
  })
}

const banModel = ref(false)

// host
const host = ref(false)
useIntervalFn(() => {
  ZoomMtg.getCurrentUser({
    success: (i: any) => host.value = i.result.currentUser.isHost,
  })
}, 1000)

const leaveWaitting = () => {
  if (waitingRoom.value) {
    zoom.$patch({ model: true })
    zoomClient.leaveClient()
    waitingRoom.value = false
  }
  else {
    if (host.value)
      banModel.value = true

    else
      zoomClient.leaveClient()
  }
}
</script>

<template>
  <div class="flex flex-row px-3 py-1 justify-between items-center text-lg bg-neutral-900">
    <div class="flex gap-4 lt-sm:flex-col lt-sm:gap-none">
      <ATime v-if="expiration" :offset="expirationConvert.getTime()" />
      <div v-if="recordTimeStamp" class="text-red-600 flex items-center gap-2">
        <div class="w-6 h-6 rounded-full bg-red-600" />
        録画ON
      </div>
    </div>
    <div class="flex flex-row items-center gap-2">
      <button
        class="bg-red-600 text-white min-w-[100px] px-5 py-1 border border-black dark:border-white mr-5 rounded-sm"
        lt-sm="min-w-[50px]"
        @click="leaveWaitting"
      >
        退出
      </button>
      <button class="cursor-pointer flex items-center" :disabled="loading || waitingRoom" @click="toggleModal()">
        <div class="i-bi:person-fill" />
        {{ account.data.name }}
      </button>
      <div class="i-bi:question-square" />
      <div v-if="isDesign7" ref="target" class="i-charm:menu-hamburger" @click="handleCloseMenu" />
      <div v-if="(menu && isDesign7)" absolute top-full right-0 bg-white>
        <div v-for="(v, tab) in tempObj" :key="tab" class="bg-neutral-900 px-2 py-1 mt-[1px]" @click="() => openSelected(tab)">
          {{ v }}
        </div>
      </div>
    </div>
    <OInputName
      v-if="modal" class="z-200"
      :rename="true"
      placeholder="ニックネーム／会社名"
      :position-show="false"
      @inputName="inputNameEvent"
    />
    <AWarningModel
      v-if="banModel && host" :text="MESSAGE_ALERT.LEAVE_MEETING_TITLE" :message="MESSAGE_ALERT.LEAVE_MEETING_MESSAGE"
      @close="banModel = false" @accept="() => {
        zoomClient.leaveClient()
        banModel = false
      }"
    />
  </div>
</template>

<style scoped></style>
